VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "DOGS102-6  USB Ansteuerung mit FT232 RL von Andreas Koehler"
   ClientHeight    =   11565
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   16380
   LinkTopic       =   "Form1"
   ScaleHeight     =   11565
   ScaleWidth      =   16380
   StartUpPosition =   3  'Windows-Standard
   Begin VB.TextBox Text2 
      Height          =   375
      Left            =   360
      TabIndex        =   8
      Top             =   9960
      Width           =   13815
   End
   Begin VB.CommandButton Textschreiben 
      Caption         =   "Textschreiben"
      Height          =   1095
      Left            =   14400
      TabIndex        =   7
      Top             =   9360
      Width           =   1815
   End
   Begin VB.CommandButton Dateiladen 
      Caption         =   "Datei laden"
      Height          =   1095
      Left            =   14400
      TabIndex        =   6
      Top             =   5280
      Width           =   1815
   End
   Begin VB.CommandButton Dateispeichern 
      Caption         =   "Datei speichern"
      Height          =   1095
      Left            =   14400
      TabIndex        =   5
      Top             =   6600
      Width           =   1815
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Editor einblenden"
      Height          =   1095
      Left            =   14400
      TabIndex        =   4
      Top             =   4080
      Width           =   1815
   End
   Begin VB.CommandButton Bildschreiben 
      Caption         =   "Bildschreiben"
      Height          =   1095
      Left            =   14400
      TabIndex        =   3
      Top             =   2880
      Width           =   1815
   End
   Begin VB.CommandButton LCDloeschen 
      Caption         =   "LCD loeschen"
      Height          =   1215
      Left            =   14400
      TabIndex        =   2
      Top             =   1440
      Width           =   1815
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Schliessen"
      Height          =   1215
      Left            =   14400
      TabIndex        =   1
      Top             =   7920
      Width           =   1815
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Start"
      Height          =   1095
      Left            =   14400
      TabIndex        =   0
      Top             =   120
      Width           =   1815
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Rem Ansteuerung DOGS128-6 ueber FT232RL
Rem mit 38400 baud
Rem   Pin 40 Anzeige /CS = Pin 11 FT232 CTS Wertigkeit 8
Rem   Pin 39 Anzeige /Reset = Pin 2 FT232 DTR Wertigkeit 16
Rem   Pin 38 Anzeige A0   = Pin 3 FT232 RTS Wertigkeit 4
Rem   Pin 37 Anzeige Clock  = Pin 2 FT 232 RxD  Wertigkeit 2
Rem   Pin 36 Anzeige Data  =  Pin 1 FT 232 TxD  wertigkeit 1
Dim t As Integer
Dim Buffer
Dim Bufz As String
Dim Ausbyte As Byte
Dim Binaer  As String
Dim Code As String
Dim j As Long
Dim l As Long
Dim p As Long
Dim lngHandle As Long
Dim k As Long
Dim i As Long
Dim z As Long
Dim Bildz As Byte
Dim Wert As Byte
Dim Lnge As Integer
Dim Lauf As Integer
Dim sAppPath As String
Dim Namedata As String
Dim BW As Integer
Dim BB As Integer
Dim ZSpalte As Long
Dim ZZeile As Long
Dim Zeichen As String
Dim Buchstabenzeichen() As String
Dim y As Integer
Dim EinG(1100) As Byte

Private Sub Command1_Click()
Rem Schnittstelle ffnen
INITFT              'USB Verbindung herstellen
SETBAUD             'Setzen der Baudrate
SETBITMODE          'Asynchroner Bitbang Modus
InitLCD             'Initialisierung der LCD
End Sub
Private Sub Load_Form()
'Beenden des Programms
End Sub
Private Sub INITFT()
If FT_Open(0, lngHandle) <> 0 Then
   MsgBox "Open failed"
   End
End If
'Print " FTDI 232 RL erfolgreich geoeffnet"
'Print "FTDI hat den USBHandle : " & lngHandle
End Sub
Private Sub SETBAUD()
'Setzen der Baudrate auf 38400
If FT_SetBaudRate(lngHandle, 38400) <> 0 Then
   MsgBox "Baudraten Einstellungsfehler"
   End
End If
'Print "FTDI 232 Baudrate auf 38400 Baud gesetzt"
End Sub
Private Sub SETBITMODE()
' Bitmode alles Ausgang asynchroner serieller Bit Bang Mode
 If FT_SetBitMode(lngHandle, &HFF, &H1) <> 0 Then
    MsgBox "Bitmode fehlerhaft gesetzt"
    End
 End If
 'Print "serieller Bit-Bang Mode erfolgreich gesetzt"
End Sub
Private Sub dattakt()
'Takt fuer Displaydaten
'Ausgabefolge mit Taktsignal im Buffer zusammensetzen
 For i = 1 To 7
If Mid$(Binaer, i, 1) = 1 Then
   Buffer = Buffer & Chr(241)
   Buffer = Buffer & Chr(243)
   Buffer = Buffer & Chr(241)
   Else: Buffer = Buffer & Chr(240)
         Buffer = Buffer & Chr(242)
         Buffer = Buffer & Chr(240)
   End If
   Next i
 ' und achtes Bit, dabei muss A0 gesetzt sein
 If Mid$(Binaer, i, 1) = 1 Then
   Buffer = Buffer & Chr(245)
   Buffer = Buffer & Chr(247)
   Buffer = Buffer & Chr(245)
   Else: Buffer = Buffer & Chr(244)
         Buffer = Buffer & Chr(246)
         Buffer = Buffer & Chr(244)
   End If
 End Sub
Private Sub InitLCD()
'InitBytes fr die Initialisierung der LCD als Kommandos
Buffer = ""
Binbyte (&H40)     'Display Start line 0
comtakt
Binbyte (&HA1)     'Seg reverse
comtakt
Binbyte (&HC0)     'Normal COM0...63
comtakt
Binbyte (&HA4)     'Disable Set all Pixel on
comtakt
Binbyte (&HA6)     'Display inverse off
comtakt
Binbyte (&HA2)     'SET BIAS 1/9 (Duty 1/65)
comtakt
Binbyte (&H2F)     'Booster, Regulator,Folloer on
comtakt
Binbyte (&H27)     'Set Contrast 1
comtakt
Binbyte (&H81)     'Set Contrast 2
comtakt
Binbyte (&H10)     'Set Contrast 3
comtakt
Binbyte (&HFA)     'Set temperature Compensation
comtakt
Binbyte (&H90)     'Curve -0,11% /Grad
comtakt
Binbyte (&HAF)     'Display on
comtakt
Komaus             'Kommandoausgabe
End Sub
 Private Sub comtakt()
'Takt fr Kommandos
'Ausgabefolge mit Taktsignal im Buffer zusammensetzen
 For i = 1 To 8
If Mid$(Binaer, i, 1) = 1 Then
   Buffer = Buffer & Chr(241)
   Buffer = Buffer & Chr(243)
   Buffer = Buffer & Chr(241)
   Else: Buffer = Buffer & Chr(240)
         Buffer = Buffer & Chr(242)
         Buffer = Buffer & Chr(240)
   End If
   Next i
 End Sub
Private Sub Komaus()
Buflen = Len(Buffer)
If FT_Write(lngHandle, Buffer, Buflen, 0) <> 0 Then
    MsgBox "Schreiben fehlerhaft"
    End
End If
End Sub
Private Sub SchliessenFT()
' Schliessen des FTDI Controllers
If FT_Close(lngHandle) <> 0 Then
    MsgBox "Schliessen FTDI Schaltkreis fehlerhaft"
End If
End Sub
Private Sub Unload_Form()

End Sub
Public Function Binbyte(ByVal Value As Byte) As String
'Umwandeln eines Bytes in Bytes fuer Ausgabestring
Binbyte = ""
For i = 7 To 0 Step -1
If (Value And (2 ^ i)) = 2 ^ i Then
          Binbyte = Binbyte & "1"
    Else: Binbyte = Binbyte & "0"
    End If
 Next i
 Binaer = Binbyte
End Function
Private Sub Command4_Click()
'Bild fuer Editor erstellen
Bild
End Sub

Private Sub Command3_Click()
SchliessenFT
End Sub
Private Sub Dateiladen_Click()
'Editorbild zeichnen
Bild
'Dateinamen abfragen
Dateiname$ = InputBox("Dateinamen")
FileName = App.Path & "\" & Dateiname & ".lcd"
'Datei laden
Dateinummer = FreeFile
Open FileName For Binary As #Dateinummer
For j = 0 To 1023
 Get #Dateinummer, , EinG(j)
 Next j
 Close #Dateinummer
 'Datei ist geladen
Lauf = 0
YY = 0
QQ = 0       'Zaehlvariable fuer Y Pos
Pageoffset = 800
For Page = 0 To 7
For XX = 0 To 12700 Step 100
QQ = 0
   For BW = 0 To 7
         If (EinG(Lauf) And ((2 ^ BW))) = (2 ^ BW) Then
          Line (XX + 20, YY + 20)-(XX + 80, YY + 80), vbRed, BF
          End If
    QQ = ((QQ + 100) Mod 800)
    YY = Page * Pageoffset + QQ
    Next BW
    Lauf = Lauf + 1
 Next XX
 YY = YY + Pageoffset
Next Page
End Sub
Private Sub Dateispeichern_Click()
Dateiname$ = InputBox("Dateinamen")
FileName = App.Path & "\" & Dateiname & ".lcd"
Dateinummer = FreeFile
Open FileName For Binary As #Dateinummer
   For j = 0 To 1023
   Put #Dateinummer, , EinG(j)
   Next j
Close #Dateinummer
End Sub
Private Sub LCDloeschen_Click()
Buffer = ""
For Page = 0 To 7
Binbyte (&HB0 + Page)   'Page Adresse setzen
comtakt
Komaus
Binbyte (&H10)       'Highteil Spalte
comtakt
Komaus
Binbyte (&H0)        'Lowteil Spalte
comtakt
Komaus
Buffer = ""
For Spalte = 1 To 128
Binbyte (&H0)        'Byte 00 = leer
dattakt
Next Spalte
Komaus
Next Page
ZSpalte = 0
ZZeile = 0
End Sub
Private Sub Bildschreiben_Click()
For Page = 0 To 7
Buffer = ""
Binbyte (&HB0 + Page)
comtakt
Komaus
Buffer = ""
Binbyte (&H10)
comtakt
Komaus
Buffer = ""
Binbyte (&H0)
comtakt
Komaus
Buffer = ""
For Spalte = 0 To 128
Binbyte (EinG((128 * Page) + Spalte))
dattakt
Next Spalte
Komaus
Next Page
End Sub
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, y As Single)
'Bild
  If (X < 12800) And (y < 6400) Then
      XX = Int(X / 100) * 100
      YY = Int(y / 100) * 100
      'Rechteck fuellen
      Line (XX + 20, YY + 20)-(XX + 80, YY + 80), BackColor, BF
      XB = Int(X / 100)
      YB = Int(y / 100)
       'Bitwertigkeit berechnen
        BW = YB Mod 8
        'Byte berechnen
        BB = ((Int(YB / 8) * 128) + XB)
        'Byte modifizieren
        Lauf = BB
        EinG(Lauf) = (EinG(Lauf) Xor (2 ^ BW))
           If (EinG(Lauf) And ((2 ^ BW))) = (2 ^ BW) Then
           Line (XX + 20, YY + 20)-(XX + 80, YY + 80), vbRed, BF
           End If
    End If

End Sub

Private Sub Bild()
'Rahmen
Line (0, 0)-(12800, 6400), 1, B
'senkrechtes Raster
For X = 100 To 12700 Step 100
Line (X, 0)-(X, 6400)
Next X
'waagerechtes Raster
For y = 100 To 6300 Step 100
Line (0, y)-(12800, y)
Next y
'Feld von Bytes mit 00H anlegen
For Lauf = 0 To 1024
EinG(Lauf) = &H0
Next Lauf
End Sub
Private Sub Text1_Change()
Dateiname = Text1.Text
End Sub
Private Sub Textschreiben_Click()
For y = 1 To Len(Text2)
Code = Mid$(Text2, y, 1)
Textausgabe
Next y
End Sub
Private Sub Textausgabe()
If ZSpalte = 0 Then
Buffer = ""
Binbyte (&HB0 + ZZeile)
comtakt
Komaus
Buffer = ""
Binbyte (&H10)
comtakt
Komaus
Buffer = ""
Binbyte (&H0)
comtakt
Komaus
ZSpalte = 0
End If
Buffer = ""
If ZSpalte < 128 Then
Buchstabe (Code)
Buchstabenzeichen = Split(Zeichen, ";", -1, vbBinaryCompare)
For z = 0 To 7
Zeichen = Val(Buchstabenzeichen(z))
'Print z, Zeichen
Binbyte (Zeichen)
dattakt
ZSpalte = ZSpalte + 1
Next z
Komaus
Else
ZSpalte = 0
If (ZZeile < 7) Then
ZZeile = ZZeile + 1
Else
LCDloeschen_Click
End If
Cls
'Print "neue Zeile"
End If
End Sub

Private Function Buchstabe(Code)
Select Case Code
Case "A": Zeichen = "&H0;&H7C;&H12;&H11;&H11;&H12;&H7C;&H0" 'Buchstabe A
Case "B": Zeichen = "&H0;&H7F;&H49;&H49;&H4E;&H30;&H0;&H0"  'Buchstabe B
Case "C": Zeichen = "&H0;&H1C;&H22;&H41;&H41;&H22;&H0;&H0"  'Buchstabe C
Case "D": Zeichen = "&H0;&H7F;&H41;&H41;&H22;&H1C;&H0;&H0"  'Buchstabe D
Case "E": Zeichen = "&H0;&H7F;&H49;&H49;&H41;&H41;&H0;&H0"  'Buchstabe E
Case "F": Zeichen = "&H0;&H7F;&H9;&H9;&H1;&H1;&H0;&H0"      'Buchstabe F
Case "G": Zeichen = "&H0;&H3E;&H41;&H49;&H49;&H3A;&H0;&H0"  'Buchstabe G
Case "H": Zeichen = "&H0;&H7F;&H8;&H8;&H8;&H7F;&H0;&H0"     'Buchstabe H
Case "I": Zeichen = "&H0;&H0;&H41;&H7F;&H41;&H0;&H0;&H0"    'Buchstabe I
Case "J": Zeichen = "&H0;&H20;&H41;&H41;&H21;&H1F;&H0;&H0"  'Buchstabe J
Case "K": Zeichen = "&H0;&H7F;&H8;&H14;&H22;&H41;&H0;&H0"   'Buchstabe K
Case "L": Zeichen = "&H0;&H7F;&H40;&H40;&H40;&H40;&H0;&H0"  'Buchstabe L
Case "M": Zeichen = "&H0;&H7F;&H4;&H18;&H4;&H7F;&H0;&H0"    'Buchstabe M
Case "N": Zeichen = "&H0;&H7F;&H2;&HC;&H30;&H7F;&H0;&H0"    'Buchstabe N
Case "O": Zeichen = "&H0;&H3E;&H41;&H41;&H41;&H3E;&H0;&H0"  'Buchstabe O
Case "P": Zeichen = "&H0;&H7F;&H9;&H9;&H9;&H6;&H0;&H0"      'Buchstabe P
Case "Q": Zeichen = "&H0;&H3E;&H41;&H51;&H61;&H7E;&H0;&H0"  'Buchstabe Q
Case "R": Zeichen = "&H0;&H7F;&H19;&H29;&H49;&H6;&H0;&H0"   'Buchstabe R
Case "S": Zeichen = "&H0;&H26;&H49;&H49;&H49;&H32;&H0;&H0"  'Buchstabe S
Case "T": Zeichen = "&H0;&H1;&H1;&H7F;&H1;&H1;&H0;&H0"      'Buchstabe T
Case "U": Zeichen = "&H0;&H3F;&H40;&H40;&H40;&H3F;&H0;&H0"  'Buchstabe U
Case "V": Zeichen = "&H0;&H1F;&H20;&H40;&H20;&H1F;&H0;&H0"  'Buchstabe V
Case "W": Zeichen = "&H0;&H3F;&H40;&H30;&H40;&H3F;&H0;&H0"  'Buchstabe W
Case "X": Zeichen = "&H0;&H63;&H14;&H8;&H14;&H63;&H0;&H0"   'Buchstabe X
Case "Y": Zeichen = "&H0;&H3;&H4;&H78;&H4;&H3;&H0;&H0"      'Buchstabe Y
Case "Z": Zeichen = "&H0;&H61;&H51;&H49;&H45;&H43;&H0;&H0"  'Buchstabe Z
Case "0": Zeichen = "&H0;&H3E;&H51;&H49;&H45;&H3E;&H0;&H0"  'Zahl 0
Case "1": Zeichen = "&H0;&H4;&H42;&H7F;&H40;&H0;&H0;&H0"    'Zahl 1
Case "2": Zeichen = "&H0;&H62;&H51;&H49;&H46;&H0;&H0;&H0"   'Zahl 2
Case "3": Zeichen = "&H0;&H0;&H22;&H49;&H49;&H36;&H0;&H0"   'Zahl 3
Case "4": Zeichen = "&H0;&HF;&H8;&H7C;&H8;&H0;&H0;&H0"      'Zahl 4
Case "5": Zeichen = "&H0;&H47;&H49;&H49;&H30;&H0;&H0;&H0"   'Zahl 5
Case "6": Zeichen = "&H0;&H36;&H49;&H49;&H30;&H0;&H0;&H0"   'Zahl 6
Case "7": Zeichen = "&H0;&H1;&H11;&H79;&H17;&H0;&H0;&H0"    'Zahl 7
Case "8": Zeichen = "&H0;&H36;&H49;&H49;&H36;&H0;&H0;&H0"   'Zahl 8
Case "9": Zeichen = "&H0;&H6;&H49;&H49;&H3E;&H0;&H0;&H0"    'Zahl 9
Case Else: Zeichen = "&H0;&H0;&H0;&H0;&H0;&H0;&H0;&H0"
End Select
End Function

